﻿Imports System.Runtime.CompilerServices
Imports System.Runtime.Serialization.Formatters.Binary

<HideModuleName()> Public Module SaveLoad
    <Extension()> Public Sub SaveXml(Of T)(ByVal obj As T, ByVal file As String)
        Using fs As New IO.FileStream(file, IO.FileMode.OpenOrCreate)
            Dim xmlSer As New Xml.Serialization.XmlSerializer(GetType(T))
            xmlSer.Serialize(fs, obj)
            fs.Flush()
        End Using
    End Sub

    <Extension()> Public Sub LoadXml(Of T)(ByRef obj As T, ByVal file As String)
        Using fs As New IO.FileStream(file, IO.FileMode.OpenOrCreate)
            Dim xmlSer As New Xml.Serialization.XmlSerializer(GetType(T))
            obj = DirectCast(xmlSer.Deserialize(fs), T)
        End Using
    End Sub

    <Extension()> Public Sub SaveBin(Of T)(ByVal obj As T, ByVal file As String)
        Using fs As New IO.FileStream(file, IO.FileMode.OpenOrCreate)
            Dim bf As New BinaryFormatter
            bf.Serialize(fs, obj)
            fs.Flush()
        End Using
    End Sub

    <Extension()> Public Sub LoadBin(Of T)(ByRef obj As T, ByVal file As String)
        Using fs As New IO.FileStream(file, IO.FileMode.OpenOrCreate)
            Dim bf As New BinaryFormatter
            obj = DirectCast(bf.Deserialize(fs), T)
        End Using
    End Sub
End Module

